const url_all = {
  DEV: `http://192.168.50.215:8011`, // 杜华杰
  TEST: `http://121.36.17.6:8002`, // 外网测试
  TEST_2: `http://67mccw.natappfree.cc`, // 杜华杰穿透
  PROD: `http://192.168.50.215:8011`, // 生产

  PROD_TEST_2: `http://192.168.54.75:8011`, // 国家局杜华杰测试
  PROD_TEST_3: `http://192.168.50.215:8011`, // 生产测试3
};

let BASEURL = url_all["TEST"];

const request = (options) => {
  const token = uni.getStorageSync("token");

  return new Promise((resolve, reject) => {
    uni.request({
      ...options,
      url: BASEURL + options.url,
      header: {
        Authorization: token ? `Bearer ${token}` : "",
        ...options.header,
      },
      success: (res) => {
        // console.log("《===================接口信息===================");
        // console.log("后端返回:", res);
        // console.log("请求地址:", BASEURL + options.url);
        // console.log("请求方式:", options.method);
        // console.log("请求参数:", options.data);
        // console.log("剥壳:", res.data);
        // console.log("===================接口信息===================》");

        if (res.statusCode === 200) {
          resolve(res.data);
        } else if (res.statusCode === 401 || res.statusCode === 502) {
          // token失效，清除本地存储并跳转到登录页
          uni.clearStorageSync();
          uni.reLaunch({
            url: "/pages/login/login",
          });
          reject(new Error("未授权或token已过期"));
        } else {
          reject(res);
        }
      },
      fail: (err) => {
        reject(err);
      },
    });
  });
};

export default request;

// token 白名单
function whiteList(config) {
  let list = [config.url == "/usr/session" && config.method == "POST"];
  let bol = false;
  for (const item of list) {
    if (item) {
      bol = true;
    }
  }
  return bol;
}
